import { EvaluatedArgs } from '../compiled/expressions/args';
import { DOMChanges } from '../dom/helper';
import { DynamicScope } from '../environment';
import { Destroyable } from '@glimmer/util';
export interface ModifierManager<T> {
    create(element: Element, args: EvaluatedArgs, dynamicScope: DynamicScope, dom: DOMChanges): T;
    install(modifier: T): void;
    update(modifier: T): void;
    getDestructor(modifier: T): Destroyable;
}
